diff --git a/src/backend/access/index/indexam.c b/src/backend/access/index/indexam.c
index aa0d4b143..c3e8e54fb 100644
--- a/src/backend/access/index/indexam.c
+++ b/src/backend/access/index/indexam.c
@@ -13,18 +13,15 @@
  * INTERFACE ROUTINES
  *		index_open		- open an index relation by relation OID
  *		index_close		- close an index relation
- *		index_beginscan - start a scan of an index with amgettuple
+ *		index_beginscan - start a scan of an index with amgetbatch/amgettuple
  *		index_beginscan_bitmap - start a scan of an index with amgetbitmap
  *		index_rescan	- restart a scan of an index
  *		index_endscan	- end a scan
  *		index_insert	- insert an index tuple into a relation
- *		index_markpos	- mark a scan position
- *		index_restrpos	- restore a scan position
  *		index_parallelscan_estimate - estimate shared memory for parallel scan
  *		index_parallelscan_initialize - initialize parallel scan
  *		index_parallelrescan  - (re)start a parallel scan of an index
  *		index_beginscan_parallel - join parallel index scan
- *		index_getnext_tid	- amgettuple table AM helper routine
  *		index_getbitmap - get all tuples from a scan
  *		index_bulk_delete	- bulk deletion of index tuples
  *		index_vacuum_cleanup	- post-deletion cleanup of an index
@@ -42,6 +39,7 @@
 #include "postgres.h"
 
 #include "access/amapi.h"
+#include "access/indexbatch.h"
 #include "access/relation.h"
 #include "access/reloptions.h"
 #include "access/relscan.h"
@@ -254,7 +252,7 @@ index_insert_cleanup(Relation indexRelation,
 }
 
 /*
- * index_beginscan - start a scan of an index with amgettuple
+ * index_beginscan - start a scan of an index with amgetbatch/amgettuple
  *
  * Caller must be holding suitable locks on the heap and the index.
  */
@@ -339,6 +337,7 @@ index_beginscan_internal(Relation indexRelation, Relation heapRelation,
 	scan->xs_temp_snap = temp_snap;
 
 	scan->xs_snapshot = snapshot;
+	scan->MVCCScan = IsMVCCLikeSnapshot(snapshot);
 	scan->instrument = instrument;
 
 	/*
@@ -350,6 +349,7 @@ index_beginscan_internal(Relation indexRelation, Relation heapRelation,
 		scan->heapRelation = heapRelation;
 		scan->xs_want_itup = index_only_scan;
 		scan->xs_heap_continue = false;
+		scan->batchImmediateUnguard = (scan->MVCCScan && !index_only_scan);
 
 		/*
 		 * For index-only scans, find any "name" columns stored as cstrings
@@ -394,6 +394,14 @@ index_beginscan_internal(Relation indexRelation, Relation heapRelation,
 		Assert(scan->xs_getnext_slot != NULL && scan->xs_table_opaque != NULL);
 	}
 
+	/*
+	 * Bitmap index scans should never use a batch ring buffer (though can use
+	 * the scan's batch cache).  Plain index scans (and index-only scans)
+	 * should only use a batch ring buffer with an amgetbatch index AM.
+	 */
+	Assert(!scan->xs_table_opaque ? !scan->usebatchring :
+		   (indexRelation->rd_indam->amgetbatch != NULL) == scan->usebatchring);
+
 	return scan;
 }
 
@@ -420,9 +428,9 @@ index_rescan(IndexScanDesc scan,
 	Assert(nkeys == scan->numberOfKeys);
 	Assert(norderbys == scan->numberOfOrderBys);
 
-	/* reset table AM state for rescan */
+	/* tell the table AM that there's to be a rescan */
 	if (scan->xs_table_opaque)
-		table_index_scan_reset(scan);
+		table_index_scan_rescan(scan);
 
 	scan->kill_prior_tuple = false; /* for safety */
 	scan->xs_heap_continue = false;
@@ -441,7 +449,21 @@ index_endscan(IndexScanDesc scan)
 	SCAN_CHECKS;
 	CHECK_SCAN_PROCEDURE(amendscan);
 
-	/* Release resources (like buffer pins) from table accesses */
+	/*
+	 * amgetbitmap scans of an index AM that supports amgetbatch make limited
+	 * use of the scan's batch cache.  Check for that.
+	 */
+	if (!scan->usebatchring && scan->batchcache[0] != NULL)
+	{
+		Assert(scan->xs_table_opaque == NULL);
+		Assert(scan->indexRelation->rd_indam->amgetbatch != NULL);
+		pfree(index_scan_batch_base(scan, scan->batchcache[0]));
+	}
+
+	/*
+	 * Release resources (like buffer pins and batch ring buffer) held by
+	 * table AM for index scan
+	 */
 	if (scan->xs_table_opaque)
 	{
 		table_index_scan_end(scan);
@@ -461,52 +483,6 @@ index_endscan(IndexScanDesc scan)
 	IndexScanEnd(scan);
 }
 
-/* ----------------
- *		index_markpos  - mark a scan position
- * ----------------
- */
-void
-index_markpos(IndexScanDesc scan)
-{
-	SCAN_CHECKS;
-	CHECK_SCAN_PROCEDURE(ammarkpos);
-
-	scan->indexRelation->rd_indam->ammarkpos(scan);
-}
-
-/* ----------------
- *		index_restrpos	- restore a scan position
- *
- * NOTE: this only restores the internal scan state of the index AM.  See
- * comments for ExecRestrPos().
- *
- * NOTE: For heap, in the presence of HOT chains, mark/restore only works
- * correctly if the scan's snapshot is MVCC-safe; that ensures that there's at
- * most one returnable tuple in each HOT chain, and so restoring the prior
- * state at the granularity of the index AM is sufficient.  Since the only
- * current user of mark/restore functionality is nodeMergejoin.c, this
- * effectively means that merge-join plans only work for MVCC snapshots.  This
- * could be fixed if necessary, but for now it seems unimportant.
- * ----------------
- */
-void
-index_restrpos(IndexScanDesc scan)
-{
-	Assert(IsMVCCLikeSnapshot(scan->xs_snapshot));
-
-	SCAN_CHECKS;
-	CHECK_SCAN_PROCEDURE(amrestrpos);
-
-	/* reset table AM state for restoring the marked position */
-	if (scan->xs_table_opaque)
-		table_index_scan_reset(scan);
-
-	scan->kill_prior_tuple = false; /* for safety */
-	scan->xs_heap_continue = false;
-
-	scan->indexRelation->rd_indam->amrestrpos(scan);
-}
-
 /*
  * Estimates the shared memory needed for parallel scan, including any
  * AM-specific parallel scan state.
@@ -584,9 +560,9 @@ index_parallelrescan(IndexScanDesc scan)
 {
 	SCAN_CHECKS;
 
-	/* reset table AM state for rescan */
+	/* tell the table AM that there's to be a rescan */
 	if (scan->xs_table_opaque)
-		table_index_scan_reset(scan);
+		table_index_scan_rescan(scan);
 
 	/* amparallelrescan is optional; assume no-op if not provided by AM */
 	if (scan->indexRelation->rd_indam->amparallelrescan != NULL)
@@ -622,56 +598,6 @@ index_beginscan_parallel(Relation heaprel, Relation indexrel,
 									index_only_scan, true, flags);
 }
 
-/* ----------------
- * index_getnext_tid - amgettuple interface
- *
- * The result is the next TID satisfying the scan keys,
- * or NULL if no more matching tuples exist.
- *
- * This should only be called by table AM amgettuple-based index scan
- * callbacks.
- * ----------------
- */
-ItemPointer
-index_getnext_tid(IndexScanDesc scan, ScanDirection direction)
-{
-	bool		found;
-
-	SCAN_CHECKS;
-	CHECK_SCAN_PROCEDURE(amgettuple);
-
-	/* XXX: we should assert that a snapshot is pushed or registered */
-	Assert(TransactionIdIsValid(RecentXmin));
-
-	/*
-	 * The AM's amgettuple proc finds the next index entry matching the scan
-	 * keys, and puts the TID into scan->xs_heaptid.  It should also set
-	 * scan->xs_recheck and possibly scan->xs_itup/scan->xs_hitup, though we
-	 * pay no attention to those fields here.
-	 */
-	found = scan->indexRelation->rd_indam->amgettuple(scan, direction);
-
-	/* Reset kill flag immediately for safety */
-	scan->kill_prior_tuple = false;
-	scan->xs_heap_continue = false;
-
-	/* If we're out of index entries, we're done */
-	if (!found)
-	{
-		/* reset table AM state */
-		if (scan->xs_table_opaque)
-			table_index_scan_reset(scan);
-
-		return NULL;
-	}
-	Assert(ItemPointerIsValid(&scan->xs_heaptid));
-
-	pgstat_count_index_tuples(scan->indexRelation, 1);
-
-	/* Return the TID of the tuple we found. */
-	return &scan->xs_heaptid;
-}
-
 /* ----------------
  *		index_getbitmap - get all tuples at once from an index scan
  *
